codeforces #398(div.2)C

C. Garland
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Once at New Year Dima had a dream in which he was presented a fairy garland. A garland is a set of lamps, some pairs of which are connected by wires. Dima remembered that each two lamps in the garland were connected directly or indirectly via some wires. Furthermore, the number of wires was exactly one less than the number of lamps.

There was something unusual about the garland. Each lamp had its own brightness which depended on the temperature of the lamp. Temperatures could be positive, negative or zero. Dima has two friends, so he decided to share the garland with them. He wants to cut two different wires so that the garland breaks up into three parts. Each part of the garland should shine equally, i. e. the sums of lamps’ temperatures should be equal in each of the parts. Of course, each of the parts should be non-empty, i. e. each part should contain at least one lamp.

Help Dima to find a suitable way to cut the garland, or determine that this is impossible.

While examining the garland, Dima lifted it up holding by one of the lamps. Thus, each of the lamps, except the one he is holding by, is now hanging on some wire. So, you should print two lamp ids as the answer which denote that Dima should cut the wires these lamps are hanging on. Of course, the lamp Dima is holding the garland by can’t be included in the answer.

Input
The first line contains single integer n (3 ≤ n ≤ 106) — the number of lamps in the garland.

Then n lines follow. The i-th of them contain the information about the i-th lamp: the number lamp ai, it is hanging on (and 0, if is there is no such lamp), and its temperature ti ( - 100 ≤ ti ≤ 100). The lamps are numbered from 1 to n.

Output
If there is no solution, print -1.

Otherwise print two integers — the indexes of the lamps which mean Dima should cut the wires they are hanging on. If there are multiple answers, print any of them.

Examples
input
6
2 4
0 5
4 2
2 1
1 1
4 2
output
1 4
input
6
2 4
0 6
4 2
2 1
1 1
4 2
output
-1
题意:给你一棵树,树上的每个节点有权值,权值有正有负还有0,问你能不能把这棵树变成权值和相等的三部分
解题思路:我们知道要把一棵树变成3部分,就必须删除两条边,题目虽然没有说这棵树是有根树,但是我们可以把它当成有根树,令dp[i]为以i为根节点的子树的权值和,然后dfs根,如果中间出现sum/3,就删除该子树。为什么这种做法是对的,我们来简单的证明一下:假设最后是有解的,也就是可以把这棵树分成三等份,所以最后这棵树一定被删除了两条边,我们把这棵树看成有根树(以哪个节点为根没有关系,但是这里为了方便,取了一个特殊的点),也就是在这棵有根树中需要删除两条边,而在有根树中删除一条边产生的效果就是产生一棵子树,所以最后一定能得到解。需要注意的是这里删除子树的做法是让dp[u] = 0就行,u 是子树的根。

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e6 + 10;
int v1,v2,root,n,sum;
int dp[maxn];
vector<int> g[maxn];
void dfs(int u)
{
    for(int i = 0; i < g[u].size(); i++)
    {
        int v = g[u][i];
        dfs(v);
        dp[u] += dp[v];
    }
    if(dp[u] == sum/3&&u != root)
    {
        if(!v1)
        {
            v1 = u;
            dp[u] = 0;
        }
        else if(!v2)
        {
            v2 = u;
            dp[u] = 0;
        }
    }
}
int main()
{
    while(~scanf("%d",&n))
    {
        v1 = 0;
        v2 = 0;
        sum = 0;
        for(int i = 1; i <= n; i++)
        {
            g[i].clear();
        }
        for(int i = 1; i <= n; i++)
        {
            int x;
            scanf("%d%d",&x,&dp[i]);
            if(x == 0)
            {
                root = i;
            }
            else
            {
                g[x].push_back(i);
            }
            sum += dp[i];
        }
        if(sum%3 != 0)
        {
            printf("-1\n");
            exit(0);
        }
        dfs(root);
        if(v1&&v2) printf("%d %d\n",v1,v2);
        else printf("-1\n");
    }
    return 0;
}

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值